<script setup lang="ts">
import { useTableStore } from "@/stores/Table/tables";
import { ref } from "vue";
import type { VForm } from "vuetify/components";
const tableStore = useTableStore();

const dialog = ref(false);
const title = ref("Title");
const desc = ref("Desc");
const ok = ref("Ok");
const cancel = ref("Cancel");
let onOk: (value: unknown) => void;
let onCancel: (reason?: any) => void;
const openDialog = (
  titleStr: string,
  descStr: string,
  okStr: string = "Ok",
  cancelStr: string = "Cancel"
) => {
  title.value = titleStr;
  desc.value = descStr;
  ok.value = okStr;
  cancel.value = cancelStr;
  dialog.value = true;
  return new Promise((resolve, reject) => {
    onOk = resolve;
    onCancel = reject;
  });
};

defineExpose({ openDialog });

function cancelFunc() {
  dialog.value = false;
  onCancel("Cancel");
}

function okFunc() {
  dialog.value = false;
  onOk("Ok");
}
</script>

<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" persistent width="auto">
      <!-- <template v-slot:activator="{ props }">
        <v-btn color="primary" v-bind="props"> Open Dialog </v-btn>
      </template> -->
      <v-card>
        <v-card-title class="text-h5">
          {{ title }}
        </v-card-title>
        <v-card-text>{{ desc }}</v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red-darken-1" variant="text" @click="cancelFunc">
            {{ cancel }}
          </v-btn>
          <v-btn color="green-darken-1" variant="text" @click="okFunc">
            {{ ok }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>
